Loading...
Searching...
No Matches
juce::Slider Class Reference

## Detailed Description

A slider control for changing a value.

The slider can be horizontal, vertical, or rotary, and can optionally have a text-box inside it to show an editable display of the current value.

To use it, create a Slider object and use the setSliderStyle() method to set up the type you want. To set up the text-entry box, use setTextBoxStyle().

To define the values that it can be set to, see the setRange() and setValue() methods.

There are also lots of custom tweaks you can do by subclassing and overriding some of the virtual methods, such as changing the scaling, changing the format of the text display, custom ways of limiting the values, etc.

You can register Slider::Listener objects with a slider, and they'll be called when the value changes.

See also
  Slider::Listener

The documentation for this class was generated from the following file:

- juce_gui_basics/widgets/juce_Slider.h

Inheritance diagram for juce::Slider:

## Classes

struct | RotaryParameters
| Structure defining rotary parameters for a slider. More...
struct | SliderLayout
| A struct defining the placement of the slider area and the text box area relative to the bounds of the whole Slider component. More...
class | ScopedDragNotification
| An RAII class for sending slider listener drag messages. More...
struct | LookAndFeelMethods
| This abstract base class is implemented by LookAndFeel classes to provide slider drawing functionality. More...

## Public Types

enum | SliderStyle { LinearHorizontal , LinearVertical , LinearBar , LinearBarVertical , Rotary , RotaryHorizontalDrag , RotaryVerticalDrag , RotaryHorizontalVerticalDrag , IncDecButtons , TwoValueHorizontal , TwoValueVertical , ThreeValueHorizontal , ThreeValueVertical }
| The types of slider available. More...
enum | TextEntryBoxPosition { NoTextBox , TextBoxLeft , TextBoxRight , TextBoxAbove , TextBoxBelow }
| The position of the slider's text-entry box. More...
enum | DragMode { notDragging , absoluteDrag , velocityDrag }
| Describes the type of mouse-dragging that is happening when a value is being changed. More...
enum | IncDecButtonMode { incDecButtonsNotDraggable , incDecButtonsDraggable_AutoDirection , incDecButtonsDraggable_Horizontal , incDecButtonsDraggable_Vertical }
| Used by setIncDecButtonsMode(). More...
enum | ColourIds { backgroundColourId = 0x1001200 , thumbColourId = 0x1001300 , trackColourId = 0x1001310 , rotarySliderFillColourId = 0x1001311 , rotarySliderOutlineColourId = 0x1001312 , textBoxTextColourId = 0x1001400 , textBoxBackgroundColourId = 0x1001500 , textBoxHighlightColourId = 0x1001600 , textBoxOutlineColourId = 0x1001700 }
| A set of colour IDs to use to change the colour of various aspects of the slider. More...
using | Listener = SliderListener<Slider>
Public Types inherited from juce::Component
enum class | WindowControlKind { client , caption , minimise , maximise , close , sizeTop , sizeLeft , sizeRight , sizeBottom , sizeTopLeft , sizeTopRight , sizeBottomLeft , sizeBottomRight }
| Types of control that are commonly found in windows, especially title-bars. More...
enum class | FocusContainerType { none , focusContainer , keyboardFocusContainer }
| A focus container type that can be passed to setFocusContainerType(). More...
enum | FocusChangeType { focusChangedByMouseClick , focusChangedByTabKey , focusChangedDirectly }
| Enumeration used by the focusGained() and focusLost() methods. More...
enum class | FocusChangeDirection { unknown , forward , backward }
| Enumeration used by the focusGainedWithDirection() method. More...

## Public Member Functions

| Slider ()
| Creates a slider.
| Slider (const String &componentName)
| Creates a slider.
| Slider (SliderStyle style, TextEntryBoxPosition textBoxPosition)
| Creates a slider with some explicit options.
| ~Slider () override
| Destructor.
void | setSliderStyle (SliderStyle newStyle)
| Changes the type of slider interface being used.
SliderStyle | getSliderStyle () const noexcept
| Returns the slider's current style.
void | setRotaryParameters (RotaryParameters newParameters) noexcept
| Changes the properties of a rotary slider.
void | setRotaryParameters (float startAngleRadians, float endAngleRadians, bool stopAtEnd) noexcept
| Changes the properties of a rotary slider.
RotaryParameters | getRotaryParameters () const noexcept
| Changes the properties of a rotary slider.
void | setMouseDragSensitivity (int distanceForFullScaleDrag)
| Sets the distance the mouse has to move to drag the slider across the full extent of its range.
int | getMouseDragSensitivity () const noexcept
| Returns the current sensitivity value set by setMouseDragSensitivity().
void | setVelocityBasedMode (bool isVelocityBased)
| Changes the way the mouse is used when dragging the slider.
bool | getVelocityBasedMode () const noexcept
| Returns true if velocity-based mode is active.
void | setVelocityModeParameters (double sensitivity=1.0, int threshold=1, double offset=0.0, bool userCanPressKeyToSwapMode=true, ModifierKeys::Flags modifiersToSwapModes=ModifierKeys::ctrlAltCommandModifiers)
| Changes aspects of the scaling used when in velocity-sensitive mode.
double | getVelocitySensitivity () const noexcept
| Returns the velocity sensitivity setting.
int | getVelocityThreshold () const noexcept
| Returns the velocity threshold setting.
double | getVelocityOffset () const noexcept
| Returns the velocity offset setting.
bool | getVelocityModeIsSwappable () const noexcept
| Returns the velocity user key setting.
void | setSkewFactor (double factor, bool symmetricSkew=false)
| Sets up a skew factor to alter the way values are distributed.
void | setSkewFactorFromMidPoint (double sliderValueToShowAtMidPoint)
| Sets up a skew factor to alter the way values are distributed.
double | getSkewFactor () const noexcept
| Returns the current skew factor.
bool | isSymmetricSkew () const noexcept
| Returns the whether the skew is symmetric from the midpoint to both sides.
void | setIncDecButtonsMode (IncDecButtonMode mode)
| When the style is IncDecButtons, this lets you turn on a mode where the mouse can be dragged on the buttons to drag the values.
void | setTextBoxStyle (TextEntryBoxPosition newPosition, bool isReadOnly, int textEntryBoxWidth, int textEntryBoxHeight)
| Changes the location and properties of the text-entry box.
TextEntryBoxPosition | getTextBoxPosition () const noexcept
| Returns the status of the text-box.
int | getTextBoxWidth () const noexcept
| Returns the width used for the text-box.
int | getTextBoxHeight () const noexcept
| Returns the height used for the text-box.
void | setTextBoxIsEditable (bool shouldBeEditable)
| Makes the text-box editable.
bool | isTextBoxEditable () const noexcept
| Returns true if the text-box is read-only.
void | showTextBox ()
| If the text-box is editable, this will give it the focus so that the user can type directly into it.
void | hideTextBox (bool discardCurrentEditorContents)
| If the text-box currently has focus and is being edited, this resets it and takes keyboard focus away from it.
void | setValue (double newValue, NotificationType notification=sendNotificationAsync)
| Changes the slider's current value.
double | getValue () const
| Returns the slider's current value.
Value & | getValueObject () noexcept
| Returns the Value object that represents the slider's current position.
void | setRange (double newMinimum, double newMaximum, double newInterval=0)
| Sets the limits that the slider's value can take.
void | setRange (Range< double > newRange, double newInterval)
| Sets the limits that the slider's value can take.
void | setNormalisableRange (NormalisableRange< double > newNormalisableRange)
| Sets a NormalisableRange to use for the Slider values.
NormalisableRange< double > | getNormalisableRange () const noexcept
| Returns the slider's normalisable range.
Range< double > | getRange () const noexcept
| Returns the slider's range.
double | getMaximum () const noexcept
| Returns the current maximum value.
double | getMinimum () const noexcept
| Returns the current minimum value.
double | getInterval () const noexcept
| Returns the current step-size for values.
double | getMinValue () const
| For a slider with two or three thumbs, this returns the lower of its values.
Value & | getMinValueObject () noexcept
| For a slider with two or three thumbs, this returns the lower of its values.
void | setMinValue (double newValue, NotificationType notification=sendNotificationAsync, bool allowNudgingOfOtherValues=false)
| For a slider with two or three thumbs, this sets the lower of its values.
double | getMaxValue () const
| For a slider with two or three thumbs, this returns the higher of its values.
Value & | getMaxValueObject () noexcept
| For a slider with two or three thumbs, this returns the higher of its values.
void | setMaxValue (double newValue, NotificationType notification=sendNotificationAsync, bool allowNudgingOfOtherValues=false)
| For a slider with two or three thumbs, this sets the lower of its values.
void | setMinAndMaxValues (double newMinValue, double newMaxValue, NotificationType notification=sendNotificationAsync)
| For a slider with two or three thumbs, this sets the minimum and maximum thumb positions.
void | addListener (Listener *listener)
| Adds a listener to be called when this slider's value changes.
void | removeListener (Listener *listener)
| Removes a previously-registered listener.
void | setDoubleClickReturnValue (bool shouldDoubleClickBeEnabled, double valueToSetOnDoubleClick, ModifierKeys singleClickModifiers=ModifierKeys::altModifier)
| This lets you choose whether double-clicking or single-clicking with a specified key modifier moves the slider to a given position.
double | getDoubleClickReturnValue () const noexcept
| Returns the values last set by setDoubleClickReturnValue() method.
bool | isDoubleClickReturnEnabled () const noexcept
| Returns true if double-clicking to reset to a default value is enabled.
void | setChangeNotificationOnlyOnRelease (bool onlyNotifyOnRelease)
| Tells the slider whether to keep sending change messages while the user is dragging the slider.
void | setSliderSnapsToMousePosition (bool shouldSnapToMouse)
| This lets you change whether the slider thumb jumps to the mouse position when you click.
bool | getSliderSnapsToMousePosition () const noexcept
| Returns true if setSliderSnapsToMousePosition() has been enabled.
void | setPopupDisplayEnabled (bool shouldShowOnMouseDrag, bool shouldShowOnMouseHover, Component *parentComponentToUse, int hoverTimeout=2000)
| If enabled, this gives the slider a pop-up bubble which appears while the slider is being dragged or hovered-over.
Component * | getCurrentPopupDisplay () const noexcept
| If a popup display is enabled and is currently visible, this returns the component that is being shown, or nullptr if none is currently in use.
void | setPopupMenuEnabled (bool menuEnabled)
| If this is set to true, then right-clicking on the slider will pop-up a menu to let the user change the way it works.
void | setScrollWheelEnabled (bool enabled)
| This can be used to stop the mouse scroll-wheel from moving the slider.
bool | isScrollWheelEnabled () const noexcept
| Returns true if the scroll wheel can move the slider.
int | getThumbBeingDragged () const noexcept
| Returns a number to indicate which thumb is currently being dragged by the mouse.
virtual void | startedDragging ()
| Callback to indicate that the user is about to start dragging the slider.
virtual void | stoppedDragging ()
| Callback to indicate that the user has just stopped dragging the slider.
virtual void | valueChanged ()
| Callback to indicate that the user has just moved the slider.
virtual double | getValueFromText (const String &text)
| Returns a slider value for some given text.
virtual String | getTextFromValue (double value)
| Returns a text representation for a given slider value.
void | setTextValueSuffix (const String &suffix)
| Sets a suffix to append to the end of the numeric value when it's displayed as a string.
String | getTextValueSuffix () const
| Returns the suffix that was set by setTextValueSuffix().
int | getNumDecimalPlacesToDisplay () const noexcept
| Returns the best number of decimal places to use when displaying this slider's value.
void | setNumDecimalPlacesToDisplay (int decimalPlacesToDisplay)
| Modifies the best number of decimal places to use when displaying this slider's value.
virtual double | proportionOfLengthToValue (double proportion)
| Allows a user-defined mapping of distance along the slider to its value.
virtual double | valueToProportionOfLength (double value)
| Allows a user-defined mapping of value to the position of the slider along its length.
float | getPositionOfValue (double value) const
| Returns the X or Y coordinate of a value along the slider's length.
virtual double | snapValue (double attemptedValue, DragMode dragMode)
| This can be overridden to allow the slider to snap to user-definable values.
void | updateText ()
| This can be called to force the text box to update its contents.
bool | isHorizontal () const noexcept
| True if the slider moves horizontally.
bool | isVertical () const noexcept
| True if the slider moves vertically.
bool | isRotary () const noexcept
| True if the slider is in a rotary mode.
bool | isBar () const noexcept
| True if the slider is in a linear bar mode.
bool | isTwoValue () const noexcept
| True if the slider has two thumbs.
bool | isThreeValue () const noexcept
| True if the slider has three thumbs.
void | paint (Graphics &) override
| Components can override this method to draw their content.
void | resized () override
| Called when this component's size has been changed.
void | mouseDown (const MouseEvent &) override
| Called when a mouse button is pressed.
void | mouseUp (const MouseEvent &) override
| Called when a mouse button is released.
void | mouseDrag (const MouseEvent &) override
| Called when the mouse is moved while a button is held down.
void | mouseDoubleClick (const MouseEvent &) override
| Called when a mouse button has been double-clicked on a component.
void | mouseWheelMove (const MouseEvent &, const MouseWheelDetails &) override
| Called when the mouse-wheel is moved.
void | modifierKeysChanged (const ModifierKeys &) override
| Called when a modifier key is pressed or released.
void | lookAndFeelChanged () override
| Called to let the component react to a change in the look-and-feel setting.
void | enablementChanged () override
| Callback to indicate that this component has been enabled or disabled.
void | focusOfChildComponentChanged (FocusChangeType) override
| Called to indicate a change in whether or not this component is the parent of the currently-focused component.
void | colourChanged () override
| This method is called when a colour is changed by the setColour() method, or when the look-and-feel is changed by the setLookAndFeel() or sendLookAndFeelChange() methods.
void | mouseMove (const MouseEvent &) override
| Called when the mouse moves inside a component.
void | mouseExit (const MouseEvent &) override
| Called when the mouse moves out of a component.
void | mouseEnter (const MouseEvent &) override
| Called when the mouse first enters a component.
bool | keyPressed (const KeyPress &) override
| Called when a key is pressed.
std::unique_ptr< AccessibilityHandler > | createAccessibilityHandler () override
| Override this method to return a custom AccessibilityHandler for this component.
Public Member Functions inherited from juce::Component
| Component () noexcept
| Creates a component.
| ~Component () override
| Destructor.
| Component (const String &componentName) noexcept
| Creates a component, setting its name at the same time.
String | getName () const noexcept
| Returns the name of this component.
virtual void | setName (const String &newName)
| Sets the name of this component.
String | getComponentID () const noexcept
| Returns the ID string that was set by setComponentID().
void | setComponentID (const String &newID)
| Sets the component's ID string.
virtual void | setVisible (bool shouldBeVisible)
| Makes the component visible or invisible.
bool | isVisible () const noexcept
| Tests whether the component is visible or not.
virtual void | visibilityChanged ()
| Called when this component's visibility changes.
bool | isShowing () const
| Tests whether this component and all its parents are visible.
virtual void | addToDesktop (int windowStyleFlags, void *nativeWindowToAttachTo=nullptr)
| Makes this component appear as a window on the desktop.
void | removeFromDesktop ()
| If the component is currently showing on the desktop, this will hide it.
bool | isOnDesktop () const noexcept
| Returns true if this component is currently showing on the desktop.
ComponentPeer * | getPeer () const
| Returns the heavyweight window that contains this component.
virtual void | userTriedToCloseWindow ()
| For components on the desktop, this is called if the system wants to close the window.
virtual void | minimisationStateChanged (bool isNowMinimised)
| Called for a desktop component which has just been minimised or un-minimised.
virtual float | getDesktopScaleFactor () const
| Returns the default scale factor to use for this component when it is placed on the desktop.
void | toFront (bool shouldAlsoGainKeyboardFocus)
| Brings the component to the front of its siblings.
void | toBack ()
| Changes this component's z-order to be at the back of all its siblings.
void | toBehind (Component *other)
| Changes this component's z-order so that it's just behind another component.
void | setAlwaysOnTop (bool shouldStayOnTop)
| Sets whether the component should always be kept at the front of its siblings.
bool | isAlwaysOnTop () const noexcept
| Returns true if this component is set to always stay in front of its siblings.
int | getX () const noexcept
| Returns the x coordinate of the component's left edge.
int | getY () const noexcept
| Returns the y coordinate of the top of this component.
int | getWidth () const noexcept
| Returns the component's width in pixels.
int | getHeight () const noexcept
| Returns the component's height in pixels.
int | getRight () const noexcept
| Returns the x coordinate of the component's right-hand edge.
Point< int > | getPosition () const noexcept
| Returns the component's top-left position as a Point.
int | getBottom () const noexcept
| Returns the y coordinate of the bottom edge of this component.
Rectangle< int > | getBounds () const noexcept
| Returns this component's bounding box.
Rectangle< int > | getLocalBounds () const noexcept
| Returns the component's bounds, relative to its own origin.
Rectangle< int > | getBoundsInParent () const noexcept
| Returns the area of this component's parent which this component covers.
int | getScreenX () const
| Returns this component's x coordinate relative the screen's top-left origin.
int | getScreenY () const
| Returns this component's y coordinate relative the screen's top-left origin.
Point< int > | getScreenPosition () const
| Returns the position of this component's top-left corner relative to the screen's top-left.
Rectangle< int > | getScreenBounds () const
| Returns the bounds of this component, relative to the screen's top-left.
Point< int > | getLocalPoint (const Component *sourceComponent, Point< int > pointRelativeToSourceComponent) const
| Converts a point to be relative to this component's coordinate space.
Point< float > | getLocalPoint (const Component *sourceComponent, Point< float > pointRelativeToSourceComponent) const
| Converts a point to be relative to this component's coordinate space.
Rectangle< int > | getLocalArea (const Component *sourceComponent, Rectangle< int > areaRelativeToSourceComponent) const
| Converts a rectangle to be relative to this component's coordinate space.
Rectangle< float > | getLocalArea (const Component *sourceComponent, Rectangle< float > areaRelativeToSourceComponent) const
| Converts a rectangle to be relative to this component's coordinate space.
Point< int > | localPointToGlobal (Point< int > localPoint) const
| Converts a point relative to this component's top-left into a screen coordinate.
Point< float > | localPointToGlobal (Point< float > localPoint) const
| Converts a point relative to this component's top-left into a screen coordinate.
Rectangle< int > | localAreaToGlobal (Rectangle< int > localArea) const
| Converts a rectangle from this component's coordinate space to a screen coordinate.
Rectangle< float > | localAreaToGlobal (Rectangle< float > localArea) const
| Converts a rectangle from this component's coordinate space to a screen coordinate.
void | setTopLeftPosition (int x, int y)
| Moves the component to a new position.
void | setTopLeftPosition (Point< int > newTopLeftPosition)
| Moves the component to a new position.
void | setTopRightPosition (int x, int y)
| Moves the component to a new position.
void | setTopRightPosition (Point< int >)
| Moves the component to a new position.
void | setSize (int newWidth, int newHeight)
| Changes the size of the component.
void | setBounds (int x, int y, int width, int height)
| Changes the component's position and size.
void | setBounds (Rectangle< int > newBounds)
| Changes the component's position and size.
void | setBoundsRelative (float proportionalX, float proportionalY, float proportionalWidth, float proportionalHeight)
| Changes the component's position and size in terms of fractions of its parent's size.
void | setBoundsRelative (Rectangle< float > proportionalArea)
| Changes the component's position and size in terms of fractions of its parent's size.
void | setBoundsInset (BorderSize< int > borders)
| Changes the component's position and size based on the amount of space to leave around it.
void | setBoundsToFit (Rectangle< int > targetArea, Justification justification, bool onlyReduceInSize)
| Positions the component within a given rectangle, keeping its proportions unchanged.
void | setCentrePosition (int x, int y)
| Changes the position of the component's centre.
void | setCentrePosition (Point< int > newCentrePosition)
| Changes the position of the component's centre.
void | setCentreRelative (float x, float y)
| Changes the position of the component's centre.
void | centreWithSize (int width, int height)
| Changes the component's size and centres it within its parent.
void | setTransform (const AffineTransform &transform)
| Sets a transform matrix to be applied to this component.
AffineTransform | getTransform () const
| Returns the transform that is currently being applied to this component.
bool | isTransformed () const noexcept
| Returns true if a non-identity transform is being applied to this component.
int | proportionOfWidth (float proportion) const noexcept
| Returns a proportion of the component's width.
int | proportionOfHeight (float proportion) const noexcept
| Returns a proportion of the component's height.
int | getParentWidth () const noexcept
| Returns the width of the component's parent.
int | getParentHeight () const noexcept
| Returns the height of the component's parent.
Rectangle< int > | getParentMonitorArea () const
| Returns the screen coordinates of the monitor that contains this component.
int | getNumChildComponents () const noexcept
| Returns the number of child components that this component contains.
Component * | getChildComponent (int index) const noexcept
| Returns one of this component's child components, by it index.
int | getIndexOfChildComponent (const Component *child) const noexcept
| Returns the index of this component in the list of child components.
const Array< Component * > & | getChildren () const noexcept
| Provides access to the underlying array of child components.
Component * | findChildWithID (StringRef componentID) const noexcept
| Looks for a child component with the specified ID.
void | addChildComponent (Component *child, int zOrder=-1)
| Adds a child component to this one.
void | addChildComponent (Component &child, int zOrder=-1)
| Adds a child component to this one.
void | addAndMakeVisible (Component *child, int zOrder=-1)
| Adds a child component to this one, and also makes the child visible if it isn't already.
void | addAndMakeVisible (Component &child, int zOrder=-1)
| Adds a child component to this one, and also makes the child visible if it isn't already.
void | addChildAndSetID (Component *child, const String &componentID)
| Adds a child component to this one, makes it visible, and sets its component ID.
void | removeChildComponent (Component *childToRemove)
| Removes one of this component's child-components.
Component * | removeChildComponent (int childIndexToRemove)
| Removes one of this component's child-components by index.
void | removeAllChildren ()
| Removes all this component's children.
void | deleteAllChildren ()
| Removes and deletes all of this component's children.
Component * | getParentComponent () const noexcept
| Returns the component which this component is inside.
template<class TargetClass>
TargetClass * | findParentComponentOfClass () const
| Searches the parent components for a component of a specified class.
Component * | getTopLevelComponent () const noexcept
| Returns the highest-level component which contains this one or its parents.
bool | isParentOf (const Component *possibleChild) const noexcept
| Checks whether a component is anywhere inside this component or its children.
virtual void | parentHierarchyChanged ()
| Called to indicate that the component's parents have changed.
virtual void | childrenChanged ()
| Subclasses can use this callback to be told when children are added or removed, or when their z-order changes.
virtual bool | hitTest (int x, int y)
| Tests whether a given point is inside the component.
virtual WindowControlKind | findControlAtPoint (Point< float >) const
| For components that are added to the desktop, this may be called to determine what kind of control is at particular locations in the window.
virtual void | windowControlClickedClose ()
| For components that are added to the desktop, this may be called to indicate that the mouse was clicked inside the area of the "close" control.
virtual void | windowControlClickedMinimise ()
| For components that are added to the desktop, this may be called to indicate that the mouse was clicked inside the area of the "minimise" control.
virtual void | windowControlClickedMaximise ()
| For components that are added to the desktop, this may be called to indicate that the mouse was clicked inside the area of the "maximise" control.
void | setInterceptsMouseClicks (bool allowClicksOnThisComponent, bool allowClicksOnChildComponents) noexcept
| Changes the default return value for the hitTest() method.
void | getInterceptsMouseClicks (bool &allowsClicksOnThisComponent, bool &allowsClicksOnChildComponents) const noexcept
| Retrieves the current state of the mouse-click interception flags.
bool | contains (Point< int > localPoint)
| Returns true if a given point lies within this component or one of its children.
bool | contains (Point< float > localPoint)
| Returns true if a given point lies within this component or one of its children.
bool | reallyContains (Point< int > localPoint, bool returnTrueIfWithinAChild)
| Returns true if a given point lies in this component, taking any overlapping siblings into account.
bool | reallyContains (Point< float > localPoint, bool returnTrueIfWithinAChild)
| Returns true if a given point lies in this component, taking any overlapping siblings into account.
Component * | getComponentAt (int x, int y)
| Returns the component at a certain point within this one.
Component * | getComponentAt (Point< int > position)
| Returns the component at a certain point within this one.
Component * | getComponentAt (Point< float > position)
| Returns the component at a certain point within this one.
void | repaint ()
| Marks the whole component as needing to be redrawn.
void | repaint (int x, int y, int width, int height)
| Marks a subsection of this component as needing to be redrawn.
void | repaint (Rectangle< int > area)
| Marks a subsection of this component as needing to be redrawn.
void | setBufferedToImage (bool shouldBeBuffered)
| Makes the component use an internal buffer to optimise its redrawing.
Image | createComponentSnapshot (Rectangle< int > areaToGrab, bool clipImageToComponentBounds=true, float scaleFactor=1.0f, const ImageType &imageType=NativeImageType{})
| Generates a snapshot of part of this component.
void | paintEntireComponent (Graphics &context, bool ignoreAlphaLevel)
| Draws this component and all its subcomponents onto the specified graphics context.
void | setPaintingIsUnclipped (bool shouldPaintWithoutClipping) noexcept
| This allows you to indicate that this component doesn't require its graphics context to be clipped when it is being painted.
bool | isPaintingUnclipped () const noexcept
| Returns true if this component doesn't require its graphics context to be clipped when it is being painted.
void | setComponentEffect (ImageEffectFilter *newEffect)
| Adds an effect filter to alter the component's appearance.
ImageEffectFilter * | getComponentEffect () const noexcept
| Returns the current component effect.
LookAndFeel & | getLookAndFeel () const noexcept
| Finds the appropriate look-and-feel to use for this component.
void | setLookAndFeel (LookAndFeel *newLookAndFeel)
| Sets the look and feel to use for this component.
FontOptions | withDefaultMetrics (FontOptions opt) const
| Returns a copy of the FontOptions with the default metrics kind from the component's LookAndFeel.
void | sendLookAndFeelChange ()
| Calls the methods repaint(), lookAndFeelChanged(), and colourChanged() in this component and all its children recursively.
void | setOpaque (bool shouldBeOpaque)
| Indicates whether any parts of the component might be transparent.
bool | isOpaque () const noexcept
| Returns true if no parts of this component are transparent.
void | setBroughtToFrontOnMouseClick (bool shouldBeBroughtToFront) noexcept
| Indicates whether the component should be brought to the front when clicked.
bool | isBroughtToFrontOnMouseClick () const noexcept
| Indicates whether the component should be brought to the front when clicked-on.
void | setExplicitFocusOrder (int newFocusOrderIndex)
| Sets the focus order of this component.
int | getExplicitFocusOrder () const
| Returns the focus order of this component, if one has been specified.
void | setFocusContainerType (FocusContainerType containerType) noexcept
| Sets whether this component is a container for components that can have their focus traversed, and the type of focus traversal that it supports.
bool | isFocusContainer () const noexcept
| Returns true if this component has been marked as a focus container.
bool | isKeyboardFocusContainer () const noexcept
| Returns true if this component has been marked as a keyboard focus container.
Component * | findFocusContainer () const
| Returns the focus container for this component.
Component * | findKeyboardFocusContainer () const
| Returns the keyboard focus container for this component.
void | setWantsKeyboardFocus (bool wantsFocus) noexcept
| Sets a flag to indicate whether this component wants keyboard focus or not.
bool | getWantsKeyboardFocus () const noexcept
| Returns true if the component is interested in getting keyboard focus.
void | setMouseClickGrabsKeyboardFocus (bool shouldGrabFocus)
| Chooses whether a click on this component automatically grabs the focus.
bool | getMouseClickGrabsKeyboardFocus () const noexcept
| Returns the last value set with setMouseClickGrabsKeyboardFocus().
void | grabKeyboardFocus ()
| Tries to give keyboard focus to this component.
void | giveAwayKeyboardFocus ()
| If this component or any of its children currently have the keyboard focus, this will defocus it, send a focus change notification, and try to pass the focus to the next component.
bool | hasKeyboardFocus (bool trueIfChildIsFocused) const
| Returns true if this component currently has the keyboard focus.
void | moveKeyboardFocusToSibling (bool moveToNext)
| Tries to move the keyboard focus to one of this component's siblings.
virtual std::unique_ptr< ComponentTraverser > | createFocusTraverser ()
| Creates a ComponentTraverser object to determine the logic by which focus should be passed from this component.
virtual std::unique_ptr< ComponentTraverser > | createKeyboardFocusTraverser ()
| Creates a ComponentTraverser object to use to determine the logic by which keyboard focus should be passed from this component.
void | setHasFocusOutline (bool hasFocusOutline) noexcept
| Use this to indicate that the component should have an outline drawn around it when it has keyboard focus.
bool | hasFocusOutline () const noexcept
| Returns true if this component should have a focus outline.
bool | isEnabled () const noexcept
| Returns true if the component (and all its parents) are enabled.
void | setEnabled (bool shouldBeEnabled)
| Enables or disables this component.
float | getAlpha () const noexcept
| Returns the component's current transparency level.
void | setAlpha (float newAlpha)
| Changes the transparency of this component.
virtual void | alphaChanged ()
| Called when setAlpha() is used to change the alpha value of this component.
void | setMouseCursor (const MouseCursor &cursorType)
| Changes the mouse cursor shape to use when the mouse is over this component.
virtual MouseCursor | getMouseCursor ()
| Returns the mouse cursor shape to use when the mouse is over this component.
void | updateMouseCursor () const
| Forces the current mouse cursor to be updated.
virtual void | paintOverChildren (Graphics &g)
| Components can override this method to draw over the top of their children.
void | mouseMagnify (const MouseEvent &event, float scaleFactor) override
| Called when a pinch-to-zoom mouse-gesture is used.
void | setRepaintsOnMouseActivity (bool shouldRepaint) noexcept
| Causes automatic repaints when the mouse enters or exits this component.
void | addMouseListener (MouseListener *newListener, bool wantsEventsForAllNestedChildComponents)
| Registers a listener to be told when mouse events occur in this component.
void | removeMouseListener (MouseListener *listenerToRemove)
| Deregisters a mouse listener.
void | addKeyListener (KeyListener *newListener)
| Adds a listener that wants to hear about keypresses that this component receives.
void | removeKeyListener (KeyListener *listenerToRemove)
| Removes a previously-registered key listener.
virtual bool | keyStateChanged (bool isKeyDown)
| Called when a key is pressed or released.
virtual void | focusGained (FocusChangeType cause)
| Called to indicate that this component has just acquired the keyboard focus.
virtual void | focusGainedWithDirection (FocusChangeType cause, FocusChangeDirection direction)
| Called to indicate that this component has just acquired the keyboard focus.
virtual void | focusLost (FocusChangeType cause)
| Called to indicate that this component has just lost the keyboard focus.
bool | isMouseOver (bool includeChildren=false) const
| Returns true if the mouse is currently over this component.
bool | isMouseButtonDown (bool includeChildren=false) const
| Returns true if the mouse button is currently held down in this component.
bool | isMouseOverOrDragging (bool includeChildren=false) const
| True if the mouse is over this component, or if it's being dragged in this component.
Point< int > | getMouseXYRelative () const
| Returns the mouse's current position, relative to this component.
virtual void | moved ()
| Called when this component's position has been changed.
virtual void | childBoundsChanged (Component *child)
| Called when one of this component's children is moved or resized.
virtual void | parentSizeChanged ()
| Called when this component's immediate parent has been resized.
virtual void | broughtToFront ()
| Called when this component has been moved to the front of its siblings.
void | addComponentListener (ComponentListener *newListener)
| Adds a listener to be told about changes to the component hierarchy or position.
void | removeComponentListener (ComponentListener *listenerToRemove)
| Removes a component listener.
void | postCommandMessage (int commandId)
| Dispatches a numbered message to this component.
virtual void | handleCommandMessage (int commandId)
| Called to handle a command that was sent by postCommandMessage().
int | runModalLoop ()
| Runs a component modally, waiting until the loop terminates.
void | enterModalState (bool takeKeyboardFocus=true, ModalComponentManager::Callback *callback=nullptr, bool deleteWhenDismissed=false)
| Puts the component into a modal state.
void | exitModalState (int returnValue=0)
| Ends a component's modal state.
bool | isCurrentlyModal (bool onlyConsiderForemostModalComponent=true) const noexcept
| Returns true if this component is the modal one.
bool | isCurrentlyBlockedByAnotherModalComponent () const
| Checks whether there's a modal component somewhere that's stopping this one from receiving messages.
virtual bool | canModalEventBeSentToComponent (const Component *targetComponent)
| When a component is modal, this callback allows it to choose which other components can still receive events.
virtual void | inputAttemptWhenModal ()
| Called when the user tries to click on a component that is blocked by another modal component.
NamedValueSet & | getProperties () noexcept
| Returns the set of properties that belong to this component.
const NamedValueSet & | getProperties () const noexcept
| Returns the set of properties that belong to this component.
Colour | findColour (int colourID, bool inheritFromParent=false) const
| Looks for a colour that has been registered with the given colour ID number.
void | setColour (int colourID, Colour newColour)
| Registers a colour to be used for a particular purpose.
void | removeColour (int colourID)
| If a colour has been set with setColour(), this will remove it.
bool | isColourSpecified (int colourID) const
| Returns true if the specified colour ID has been explicitly set for this component using the setColour() method.
void | copyAllExplicitColoursTo (Component &target) const
| This looks for any colours that have been specified for this component, and copies them to the specified target component.
void * | getWindowHandle () const
| Returns the underlying native window handle for this component.
Positioner * | getPositioner () const noexcept
| Returns the Positioner object that has been set for this component.
void | setPositioner (Positioner *newPositioner)
| Sets a new Positioner object for this component.
void | setCachedComponentImage (CachedComponentImage *newCachedImage)
| Gives the component a CachedComponentImage that should be used to buffer its painting.
CachedComponentImage * | getCachedComponentImage () const noexcept
| Returns the object that was set by setCachedComponentImage().
void | invalidateCachedImageResources ()
| Invalidates cached images, both in the CachedComponentImage (if any) and the image effect state.
void | setViewportIgnoreDragFlag (bool ignoreDrag) noexcept
| Sets a flag to indicate whether mouse drag events on this Component should be ignored when it is inside a Viewport with drag-to-scroll functionality enabled.
bool | getViewportIgnoreDragFlag () const noexcept
| Retrieves the current state of the Viewport drag-to-scroll functionality flag.
String | getTitle () const noexcept
| Returns the title text for this component.
void | setTitle (const String &newTitle)
| Sets the title for this component.
String | getDescription () const noexcept
| Returns the description for this component.
void | setDescription (const String &newDescription)
| Sets the description for this component.
String | getHelpText () const noexcept
| Returns the help text for this component.
void | setHelpText (const String &newHelpText)
| Sets the help text for this component.
void | setAccessible (bool shouldBeAccessible)
| Sets whether this component and its children are visible to accessibility clients.
bool | isAccessible () const noexcept
| Returns true if this component and its children are visible to accessibility clients.
AccessibilityHandler * | getAccessibilityHandler ()
| Returns the accessibility handler for this component, or nullptr if this component is not accessible.
void | invalidateAccessibilityHandler ()
| Invalidates the AccessibilityHandler that is currently being used for this component.
Public Member Functions inherited from juce::MouseListener
virtual | ~MouseListener ()=default
| Destructor.
Public Member Functions inherited from juce::SettableTooltipClient
| ~SettableTooltipClient () override=default
| Destructor.
virtual void | setTooltip (const String &newTooltip)
| Assigns a new tooltip to this object.
String | getTooltip () override
| Returns the tooltip assigned to this object.
Public Member Functions inherited from juce::TooltipClient
virtual | ~TooltipClient ()=default
| Destructor.

## Public Attributes

std::function< void()> | onValueChange
| You can assign a lambda to this callback object to have it called when the slider value is changed.
std::function< void()> | onDragStart
| You can assign a lambda to this callback object to have it called when the slider's drag begins.
std::function< void()> | onDragEnd
| You can assign a lambda to this callback object to have it called when the slider's drag ends.
std::function< double(const String &)> | valueFromTextFunction
| You can assign a lambda that will be used to convert text to a slider value.
std::function< String(double)> | textFromValueFunction
| You can assign a lambda that will be used to convert a slider value to text.

## Additional Inherited Members

Static Public Member Functions inherited from juce::Component
static float JUCE_CALLTYPE | getApproximateScaleFactorForComponent (const Component *targetComponent)
| Returns the approximate scale factor for a given component by traversing its parent hierarchy and applying each transform and finally scaling this by the global scale factor.
static Component *JUCE_CALLTYPE | getCurrentlyFocusedComponent () noexcept
| Returns the component that currently has the keyboard focus.
static void JUCE_CALLTYPE | unfocusAllComponents ()
| If any component has keyboard focus, this will defocus it.
static void JUCE_CALLTYPE | beginDragAutoRepeat (int millisecondsBetweenCallbacks)
| Ensures that a non-stop stream of mouse-drag events will be sent during the current mouse-drag operation.
static bool JUCE_CALLTYPE | isMouseButtonDownAnywhere () noexcept
| Returns true if a mouse button is currently down.
static int JUCE_CALLTYPE | getNumCurrentlyModalComponents () noexcept
| Returns the number of components that are currently in a modal state.
static Component *JUCE_CALLTYPE | getCurrentlyModalComponent (int index=0) noexcept
| Returns one of the components that are currently modal.
Protected Member Functions inherited from juce::SettableTooltipClient
| SettableTooltipClient ()=default

## Member Typedef Documentation

## Listener

using juce::Slider::Listener = SliderListener<Slider>

## Member Enums

## SliderStyle

enum juce::Slider::SliderStyle

The types of slider available.

See also
  setSliderStyle, setRotaryParameters

Enumerator
LinearHorizontal | A traditional horizontal slider.
LinearVertical | A traditional vertical slider.
LinearBar | A horizontal bar slider with the text label drawn on top of it.
LinearBarVertical | A vertical bar slider with the text label drawn on top of it.

Rotary

A rotary control that you move by dragging the mouse in a circular motion, like a knob.

See also
  setRotaryParameters

RotaryHorizontalDrag

A rotary control that you move by dragging the mouse left-to-right.

See also
  setRotaryParameters

RotaryVerticalDrag

A rotary control that you move by dragging the mouse up-and-down.

See also
  setRotaryParameters

RotaryHorizontalVerticalDrag

A rotary control that you move by dragging the mouse up-and-down or left-to-right.

See also
  setRotaryParameters

IncDecButtons | A pair of buttons that increment or decrement the slider's value by the increment set in setRange().

TwoValueHorizontal

A horizontal slider that has two thumbs instead of one, so it can show a minimum and maximum value.

See also
  setMinValue, setMaxValue

TwoValueVertical

A vertical slider that has two thumbs instead of one, so it can show a minimum and maximum value.

See also
  setMinValue, setMaxValue

ThreeValueHorizontal

A horizontal slider that has three thumbs instead of one, so it can show a minimum and maximum value, with the current value being somewhere between them.

See also
  setMinValue, setMaxValue

ThreeValueVertical

A vertical slider that has three thumbs instead of one, so it can show a minimum and maximum value, with the current value being somewhere between them.

See also
  setMinValue, setMaxValue

## TextEntryBoxPosition

enum juce::Slider::TextEntryBoxPosition

The position of the slider's text-entry box.

See also
  setTextBoxStyle

Enumerator
NoTextBox | Doesn't display a text box.
TextBoxLeft | Puts the text box to the left of the slider, vertically centred.
TextBoxRight | Puts the text box to the right of the slider, vertically centred.
TextBoxAbove | Puts the text box above the slider, horizontally centred.
TextBoxBelow | Puts the text box below the slider, horizontally centred.

## DragMode

enum juce::Slider::DragMode

Describes the type of mouse-dragging that is happening when a value is being changed.

See also
  snapValue

Enumerator
notDragging | Dragging is not active.
absoluteDrag | The dragging corresponds directly to the value that is displayed.
velocityDrag | The dragging value change is relative to the velocity of the mouse movement.

## IncDecButtonMode

enum juce::Slider::IncDecButtonMode

Used by setIncDecButtonsMode().

Enumerator
incDecButtonsNotDraggable |
incDecButtonsDraggable_AutoDirection |
incDecButtonsDraggable_Horizontal |
incDecButtonsDraggable_Vertical |

## ColourIds

enum juce::Slider::ColourIds

A set of colour IDs to use to change the colour of various aspects of the slider.

These constants can be used either via the Component::setColour(), or LookAndFeel::setColour() methods.

See also
  Component::setColour, Component::findColour, LookAndFeel::setColour, LookAndFeel::findColour

Enumerator
backgroundColourId | A colour to use to fill the slider's background.
thumbColourId | The colour to draw the thumb with. It's up to the look and feel class how this is used.
trackColourId | The colour to draw the groove that the thumb moves along.
rotarySliderFillColourId | For rotary sliders, this colour fills the outer curve.
rotarySliderOutlineColourId | For rotary sliders, this colour is used to draw the outer curve's outline.
textBoxTextColourId | The colour for the text in the text-editor box used for editing the value.
textBoxBackgroundColourId | The background colour for the text-editor box.
textBoxHighlightColourId | The text highlight colour for the text-editor box.
textBoxOutlineColourId | The colour to use for a border around the text-editor box.

## Constructors and Destructors

## Slider() [1/3]

juce::Slider::Slider | ( |  | ) |

Creates a slider.

When created, you can set up the slider's style and range with setSliderStyle(), setRange(), etc.

Referenced by createAccessibilityHandler(), juce::Slider::LookAndFeelMethods::createSliderButton(), juce::Slider::LookAndFeelMethods::createSliderTextBox(), juce::Slider::LookAndFeelMethods::drawLinearSlider(), juce::Slider::LookAndFeelMethods::drawLinearSliderBackground(), juce::Slider::LookAndFeelMethods::drawLinearSliderOutline(), juce::Slider::LookAndFeelMethods::drawLinearSliderThumb(), juce::Slider::LookAndFeelMethods::drawRotarySlider(), juce::Slider::LookAndFeelMethods::getSliderEffect(), juce::Slider::LookAndFeelMethods::getSliderLayout(), juce::Slider::LookAndFeelMethods::getSliderPopupFont(), juce::Slider::LookAndFeelMethods::getSliderPopupPlacement(), juce::Slider::LookAndFeelMethods::getSliderThumbRadius(), juce::Slider::ScopedDragNotification::ScopedDragNotification(), and juce::Slider::ScopedDragNotification::~ScopedDragNotification().

## Slider() [2/3]

juce::Slider::Slider | ( | const String & | componentName | ) |

explicit

Creates a slider.

When created, you can set up the slider's style and range with setSliderStyle(), setRange(), etc.

## Slider() [3/3]

juce::Slider::Slider | ( | SliderStyle | style,
|  | TextEntryBoxPosition | textBoxPosition )

Creates a slider with some explicit options.

## ~Slider()

juce::Slider::~Slider | ( |  | ) |

override

Destructor.

## Member Functions

## setSliderStyle()

void juce::Slider::setSliderStyle | ( | SliderStyle | newStyle | ) |

Changes the type of slider interface being used.

Parameters

  newStyle | the type of interface

See also
  setRotaryParameters, setVelocityBasedMode

## getSliderStyle()

SliderStyle juce::Slider::getSliderStyle | ( |  | ) | const

noexcept

Returns the slider's current style.

See also
  setSliderStyle

## setRotaryParameters() [1/2]

void juce::Slider::setRotaryParameters | ( | RotaryParameters | newParameters | ) |

noexcept

Changes the properties of a rotary slider.

## setRotaryParameters() [2/2]

void juce::Slider::setRotaryParameters | ( | float | startAngleRadians,
|  | float | endAngleRadians,
|  | bool | stopAtEnd )

noexcept

Changes the properties of a rotary slider.

## getRotaryParameters()

RotaryParameters juce::Slider::getRotaryParameters | ( |  | ) | const

noexcept

Changes the properties of a rotary slider.

## setMouseDragSensitivity()

void juce::Slider::setMouseDragSensitivity | ( | int | distanceForFullScaleDrag | ) |

Sets the distance the mouse has to move to drag the slider across the full extent of its range.

This only applies when in modes like RotaryHorizontalDrag, where it's using relative mouse movements to adjust the slider.

References setMouseDragSensitivity().

Referenced by setMouseDragSensitivity().

## getMouseDragSensitivity()

int juce::Slider::getMouseDragSensitivity | ( |  | ) | const

noexcept

Returns the current sensitivity value set by setMouseDragSensitivity().

References getMouseDragSensitivity().

Referenced by getMouseDragSensitivity().

## setVelocityBasedMode()

void juce::Slider::setVelocityBasedMode | ( | bool | isVelocityBased | ) |

Changes the way the mouse is used when dragging the slider.

If true, this will turn on velocity-sensitive dragging, so that the faster the mouse moves, the bigger the movement to the slider. This helps when making accurate adjustments if the slider's range is quite large.

If false, the slider will just try to snap to wherever the mouse is.

References setVelocityBasedMode().

Referenced by setVelocityBasedMode().

## getVelocityBasedMode()

bool juce::Slider::getVelocityBasedMode | ( |  | ) | const

noexcept

Returns true if velocity-based mode is active.

See also
  setVelocityBasedMode

References getVelocityBasedMode().

Referenced by getVelocityBasedMode().

## setVelocityModeParameters()

void juce::Slider::setVelocityModeParameters | ( | double | sensitivity = 1.0,
|  | int | threshold = 1,
|  | double | offset = 0.0,
|  | bool | userCanPressKeyToSwapMode = true,
|  | ModifierKeys::Flags | modifiersToSwapModes = ModifierKeys::ctrlAltCommandModifiers )

Changes aspects of the scaling used when in velocity-sensitive mode.

These apply when you've used setVelocityBasedMode() to turn on velocity mode, or if you're holding down ctrl.

Parameters

  sensitivity | higher values than 1.0 increase the range of acceleration used
  threshold | the minimum number of pixels that the mouse needs to move for it to be treated as a movement
  offset | values greater than 0.0 increase the minimum speed that will be used when the threshold is reached
  userCanPressKeyToSwapMode | if true, then the user can hold down the ctrl or command key to toggle velocity-sensitive mode
  modifiersToSwapModes | this is a set of modifier flags which will be tested when determining whether to enable/disable velocity-sensitive mode

References setVelocityModeParameters().

Referenced by setVelocityModeParameters().

## getVelocitySensitivity()

double juce::Slider::getVelocitySensitivity | ( |  | ) | const

noexcept

Returns the velocity sensitivity setting.

See also
  setVelocityModeParameters

References getVelocitySensitivity().

Referenced by getVelocitySensitivity().

## getVelocityThreshold()

int juce::Slider::getVelocityThreshold | ( |  | ) | const

noexcept

Returns the velocity threshold setting.

See also
  setVelocityModeParameters

References getVelocityThreshold().

Referenced by getVelocityThreshold().

## getVelocityOffset()

double juce::Slider::getVelocityOffset | ( |  | ) | const

noexcept

Returns the velocity offset setting.

See also
  setVelocityModeParameters

References getVelocityOffset().

Referenced by getVelocityOffset().

## getVelocityModeIsSwappable()

bool juce::Slider::getVelocityModeIsSwappable | ( |  | ) | const

noexcept

Returns the velocity user key setting.

See also
  setVelocityModeParameters

References getVelocityModeIsSwappable().

Referenced by getVelocityModeIsSwappable().

## setSkewFactor()

void juce::Slider::setSkewFactor | ( | double | factor,
|  | bool | symmetricSkew = false )

Sets up a skew factor to alter the way values are distributed.

You may want to use a range of values on the slider where more accuracy is required towards one end of the range, so this will logarithmically spread the values across the length of the slider.

If the factor is < 1.0, the lower end of the range will fill more of the slider's length; if the factor is > 1.0, the upper end of the range will be expanded instead. A factor of 1.0 doesn't skew it at all.

If symmetricSkew is true, the skew factor applies from the middle of the slider to each of its ends.

To set the skew position by using a mid-point, use the setSkewFactorFromMidPoint() method instead.

See also
  getSkewFactor, setSkewFactorFromMidPoint, isSymmetricSkew

References setSkewFactor().

Referenced by setSkewFactor().

## setSkewFactorFromMidPoint()

void juce::Slider::setSkewFactorFromMidPoint | ( | double | sliderValueToShowAtMidPoint | ) |

Sets up a skew factor to alter the way values are distributed.

This allows you to specify the slider value that should appear in the centre of the slider's visible range.

See also
  setSkewFactor, getSkewFactor, isSymmetricSkew

References setSkewFactorFromMidPoint().

Referenced by setSkewFactorFromMidPoint().

## getSkewFactor()

double juce::Slider::getSkewFactor | ( |  | ) | const

noexcept

Returns the current skew factor.

See setSkewFactor for more info.

See also
  setSkewFactor, setSkewFactorFromMidPoint, isSymmetricSkew

References getSkewFactor().

Referenced by getSkewFactor().

## isSymmetricSkew()

bool juce::Slider::isSymmetricSkew | ( |  | ) | const

noexcept

Returns the whether the skew is symmetric from the midpoint to both sides.

See setSkewFactor for more info.

See also
  getSkewFactor, setSkewFactor, setSkewFactorFromMidPoint

References isSymmetricSkew().

Referenced by isSymmetricSkew().

## setIncDecButtonsMode()

void juce::Slider::setIncDecButtonsMode | ( | IncDecButtonMode | mode | ) |

When the style is IncDecButtons, this lets you turn on a mode where the mouse can be dragged on the buttons to drag the values.

By default this is turned off. When enabled, clicking on the buttons still works them as normal, but by holding down the mouse on a button and dragging it a little distance, it flips into a mode where the value can be dragged. The drag direction can either be set explicitly to be vertical or horizontal, or can be set to incDecButtonsDraggable_AutoDirection so that it depends on whether the buttons are side-by-side or above each other.

## setTextBoxStyle()

void juce::Slider::setTextBoxStyle | ( | TextEntryBoxPosition | newPosition,
|  | bool | isReadOnly,
|  | int | textEntryBoxWidth,
|  | int | textEntryBoxHeight )

Changes the location and properties of the text-entry box.

Parameters

  newPosition | where it should go (or NoTextBox to not have one at all)
  isReadOnly | if true, it's a read-only display
  textEntryBoxWidth | the width of the text-box in pixels. Make sure this leaves enough room for the slider as well!
  textEntryBoxHeight | the height of the text-box in pixels. Make sure this leaves enough room for the slider as well!

See also
  setTextBoxIsEditable, getValueFromText, getTextFromValue

## getTextBoxPosition()

TextEntryBoxPosition juce::Slider::getTextBoxPosition | ( |  | ) | const

noexcept

Returns the status of the text-box.

See also
  setTextBoxStyle

## getTextBoxWidth()

int juce::Slider::getTextBoxWidth | ( |  | ) | const

noexcept

Returns the width used for the text-box.

See also
  setTextBoxStyle

References getTextBoxWidth().

Referenced by getTextBoxWidth().

## getTextBoxHeight()

int juce::Slider::getTextBoxHeight | ( |  | ) | const

noexcept

Returns the height used for the text-box.

See also
  setTextBoxStyle

References getTextBoxHeight().

Referenced by getTextBoxHeight().

## setTextBoxIsEditable()

void juce::Slider::setTextBoxIsEditable | ( | bool | shouldBeEditable | ) |

Makes the text-box editable.

By default this is true, and the user can enter values into the textbox, but it can be turned off if that's not suitable.

See also
  setTextBoxStyle, getValueFromText, getTextFromValue

References setTextBoxIsEditable().

Referenced by setTextBoxIsEditable().

## isTextBoxEditable()

bool juce::Slider::isTextBoxEditable | ( |  | ) | const

noexcept

Returns true if the text-box is read-only.

See also
  setTextBoxStyle

References isTextBoxEditable().

Referenced by isTextBoxEditable().

## showTextBox()

void juce::Slider::showTextBox | ( |  | ) |

If the text-box is editable, this will give it the focus so that the user can type directly into it.

This is basically the effect as the user clicking on it.

References showTextBox().

Referenced by showTextBox().

## hideTextBox()

void juce::Slider::hideTextBox | ( | bool | discardCurrentEditorContents | ) |

If the text-box currently has focus and is being edited, this resets it and takes keyboard focus away from it.

Parameters

  discardCurrentEditorContents | if true, the slider's value will be left unchanged; if false, the current contents of the text editor will be used to set the slider position before it is hidden.

References hideTextBox().

Referenced by hideTextBox().

## setValue()

void juce::Slider::setValue | ( | double | newValue,
|  | NotificationType | notification = sendNotificationAsync )

Changes the slider's current value.

This will trigger a callback to Slider::Listener::sliderValueChanged() for any listeners that are registered, and will synchronously call the valueChanged() method in case subclasses want to handle it.

Parameters

  newValue | the new value to set - this will be restricted by the minimum and maximum range, and will be snapped to the nearest interval if one has been set
  notification | can be one of the NotificationType values, to request a synchronous or asynchronous call to the valueChanged() method of any Slider::Listeners that are registered. A notification will only be sent if the Slider's value has changed.

References juce::sendNotificationAsync, and setValue().

Referenced by createAccessibilityHandler(), and setValue().

## getValue()

double juce::Slider::getValue | ( |  | ) | const

Returns the slider's current value.

References getValue().

Referenced by getValue().

## getValueObject()

Value & juce::Slider::getValueObject | ( |  | ) |

noexcept

Returns the Value object that represents the slider's current position.

You can use this Value object to connect the slider's position to external values or setters, either by taking a copy of the Value, or by using Value::referTo() to make it point to your own Value object.

See also
  Value, getMaxValue, getMinValueObject

References getValueObject().

Referenced by getValueObject().

## setRange() [1/2]

void juce::Slider::setRange | ( | double | newMinimum,
|  | double | newMaximum,
|  | double | newInterval = 0 )

Sets the limits that the slider's value can take.

Parameters

  newMinimum | the lowest value allowed
  newMaximum | the highest value allowed
  newInterval | the steps in which the value is allowed to increase - if this is not zero, the value will always be (newMinimum + (newInterval * an integer)).

References setRange().

Referenced by setRange(), and setRange().

## setRange() [2/2]

void juce::Slider::setRange | ( | Range< double > | newRange,
|  | double | newInterval )

Sets the limits that the slider's value can take.

Parameters

  newRange | the range to allow
  newInterval | the steps in which the value is allowed to increase - if this is not zero, the value will always be (newMinimum + (newInterval * an integer)).

References setRange().

## setNormalisableRange()

void juce::Slider::setNormalisableRange | ( | NormalisableRange< double > | newNormalisableRange | ) |

Sets a NormalisableRange to use for the Slider values.

Parameters

  newNormalisableRange | the NormalisableRange to use

References setNormalisableRange().

Referenced by setNormalisableRange().

## getNormalisableRange()

NormalisableRange< double > juce::Slider::getNormalisableRange | ( |  | ) | const

noexcept

Returns the slider's normalisable range.

References getNormalisableRange().

Referenced by getNormalisableRange().

## getRange()

Range< double > juce::Slider::getRange | ( |  | ) | const

noexcept

Returns the slider's range.

References getRange().

Referenced by getRange().

## getMaximum()

double juce::Slider::getMaximum | ( |  | ) | const

noexcept

Returns the current maximum value.

See also
  setRange, getRange

References getMaximum().

Referenced by getMaximum().

## getMinimum()

double juce::Slider::getMinimum | ( |  | ) | const

noexcept

Returns the current minimum value.

See also
  setRange, getRange

References getMinimum().

Referenced by getMinimum().

## getInterval()

double juce::Slider::getInterval | ( |  | ) | const

noexcept

Returns the current step-size for values.

See also
  setRange, getRange

References getInterval().

Referenced by getInterval().

## getMinValue()

double juce::Slider::getMinValue | ( |  | ) | const

For a slider with two or three thumbs, this returns the lower of its values.

For a two-value slider, the values are controlled with getMinValue() and getMaxValue(). A slider with three values also uses the normal getValue() and setValue() methods to control the middle value.

See also
  setMinValue, getMaxValue, TwoValueHorizontal, TwoValueVertical, ThreeValueHorizontal, ThreeValueVertical

References getMinValue().

Referenced by getMinValue().

## getMinValueObject()

Value & juce::Slider::getMinValueObject | ( |  | ) |

noexcept

For a slider with two or three thumbs, this returns the lower of its values.

You can use this Value object to connect the slider's position to external values or setters, either by taking a copy of the Value, or by using Value::referTo() to make it point to your own Value object.

See also
  Value, getMinValue, getMaxValueObject

References getMinValueObject().

Referenced by getMinValueObject().

## setMinValue()

void juce::Slider::setMinValue | ( | double | newValue,
|  | NotificationType | notification = sendNotificationAsync,
|  | bool | allowNudgingOfOtherValues = false )

For a slider with two or three thumbs, this sets the lower of its values.

This will trigger a callback to Slider::Listener::sliderValueChanged() for any listeners that are registered, and will synchronously call the valueChanged() method in case subclasses want to handle it.

Parameters

  newValue | the new value to set - this will be restricted by the minimum and maximum range, and will be snapped to the nearest interval if one has been set.
  notification | can be one of the NotificationType values, to request a synchronous or asynchronous call to the valueChanged() method of any Slider::Listeners that are registered. A notification will only be sent if this value has changed.
  allowNudgingOfOtherValues | if false, this value will be restricted to being below the max value (in a two-value slider) or the mid value (in a three-value slider). If true, then if this value goes beyond those values, it will push them along with it.

See also
  getMinValue, setMaxValue, setValue

References juce::sendNotificationAsync, and setMinValue().

Referenced by createAccessibilityHandler(), and setMinValue().

## getMaxValue()

double juce::Slider::getMaxValue | ( |  | ) | const

For a slider with two or three thumbs, this returns the higher of its values.

For a two-value slider, the values are controlled with getMinValue() and getMaxValue(). A slider with three values also uses the normal getValue() and setValue() methods to control the middle value.

See also
  getMinValue, TwoValueHorizontal, TwoValueVertical, ThreeValueHorizontal, ThreeValueVertical

References getMaxValue().

Referenced by getMaxValue().

## getMaxValueObject()

Value & juce::Slider::getMaxValueObject | ( |  | ) |

noexcept

For a slider with two or three thumbs, this returns the higher of its values.

You can use this Value object to connect the slider's position to external values or setters, either by taking a copy of the Value, or by using Value::referTo() to make it point to your own Value object.

See also
  Value, getMaxValue, getMinValueObject

References getMaxValueObject().

Referenced by getMaxValueObject().

## setMaxValue()

void juce::Slider::setMaxValue | ( | double | newValue,
|  | NotificationType | notification = sendNotificationAsync,
|  | bool | allowNudgingOfOtherValues = false )

For a slider with two or three thumbs, this sets the lower of its values.

This will trigger a callback to Slider::Listener::sliderValueChanged() for any listeners that are registered, and will synchronously call the valueChanged() method in case subclasses want to handle it.

Parameters

  newValue | the new value to set - this will be restricted by the minimum and maximum range, and will be snapped to the nearest interval if one has been set.
  notification | can be one of the NotificationType values, to request a synchronous or asynchronous call to the valueChanged() method of any Slider::Listeners that are registered. A notification will only be sent if this value has changed.
  allowNudgingOfOtherValues | if false, this value will be restricted to being above the min value (in a two-value slider) or the mid value (in a three-value slider). If true, then if this value goes beyond those values, it will push them along with it.

See also
  getMaxValue, setMinValue, setValue

References juce::sendNotificationAsync, and setMaxValue().

Referenced by createAccessibilityHandler(), and setMaxValue().

## setMinAndMaxValues()

void juce::Slider::setMinAndMaxValues | ( | double | newMinValue,
|  | double | newMaxValue,
|  | NotificationType | notification = sendNotificationAsync )

For a slider with two or three thumbs, this sets the minimum and maximum thumb positions.

This will trigger a callback to Slider::Listener::sliderValueChanged() for any listeners that are registered, and will synchronously call the valueChanged() method in case subclasses want to handle it.

Parameters

  newMinValue | the new minimum value to set - this will be snapped to the nearest interval if one has been set.
  newMaxValue | the new minimum value to set - this will be snapped to the nearest interval if one has been set.
  notification | can be one of the NotificationType values, to request a synchronous or asynchronous call to the valueChanged() method of any Slider::Listeners that are registered. A notification will only be sent if one or more of the values has changed.

See also
  setMaxValue, setMinValue, setValue

References juce::sendNotificationAsync, and setMinAndMaxValues().

Referenced by createAccessibilityHandler(), and setMinAndMaxValues().

## addListener()

void juce::Slider::addListener | ( | Listener * | listener | ) |

Adds a listener to be called when this slider's value changes.

References addListener().

Referenced by addListener().

## removeListener()

void juce::Slider::removeListener | ( | Listener * | listener | ) |

Removes a previously-registered listener.

References removeListener().

Referenced by removeListener().

## setDoubleClickReturnValue()

void juce::Slider::setDoubleClickReturnValue | ( | bool | shouldDoubleClickBeEnabled,
|  | double | valueToSetOnDoubleClick,
|  | ModifierKeys | singleClickModifiers = ModifierKeys::altModifier )

This lets you choose whether double-clicking or single-clicking with a specified key modifier moves the slider to a given position.

By default this is turned off, but it's handy if you want either of these actions to act as a quick way of resetting a slider. Just pass in the value you want it to go to when double-clicked. By default the key modifier is the alt key but you can pass in another key modifier, or none to disable this behaviour.

See also
  getDoubleClickReturnValue

References setDoubleClickReturnValue().

Referenced by setDoubleClickReturnValue().

## getDoubleClickReturnValue()

double juce::Slider::getDoubleClickReturnValue | ( |  | ) | const

noexcept

Returns the values last set by setDoubleClickReturnValue() method.

See also
  setDoubleClickReturnValue

References getDoubleClickReturnValue().

Referenced by getDoubleClickReturnValue().

## isDoubleClickReturnEnabled()

bool juce::Slider::isDoubleClickReturnEnabled | ( |  | ) | const

noexcept

Returns true if double-clicking to reset to a default value is enabled.

See also
  setDoubleClickReturnValue

References isDoubleClickReturnEnabled().

Referenced by isDoubleClickReturnEnabled().

## setChangeNotificationOnlyOnRelease()

void juce::Slider::setChangeNotificationOnlyOnRelease | ( | bool | onlyNotifyOnRelease | ) |

Tells the slider whether to keep sending change messages while the user is dragging the slider.

If set to true, a change message will only be sent when the user has dragged the slider and let go. If set to false (the default), then messages will be continuously sent as they drag it while the mouse button is still held down.

References setChangeNotificationOnlyOnRelease().

Referenced by setChangeNotificationOnlyOnRelease().

## setSliderSnapsToMousePosition()

void juce::Slider::setSliderSnapsToMousePosition | ( | bool | shouldSnapToMouse | ) |

This lets you change whether the slider thumb jumps to the mouse position when you click.

By default, this is true. If it's false, then the slider moves with relative motion when you drag it.

This only applies to linear bars, and won't affect two- or three- value sliders.

References setSliderSnapsToMousePosition().

Referenced by setSliderSnapsToMousePosition().

## getSliderSnapsToMousePosition()

bool juce::Slider::getSliderSnapsToMousePosition | ( |  | ) | const

noexcept

Returns true if setSliderSnapsToMousePosition() has been enabled.

References getSliderSnapsToMousePosition().

Referenced by getSliderSnapsToMousePosition().

## setPopupDisplayEnabled()

void juce::Slider::setPopupDisplayEnabled | ( | bool | shouldShowOnMouseDrag,
|  | bool | shouldShowOnMouseHover,
|  | Component * | parentComponentToUse,
|  | int | hoverTimeout = 2000 )

If enabled, this gives the slider a pop-up bubble which appears while the slider is being dragged or hovered-over.

This can be handy if your slider doesn't have a text-box, so that users can see the value just when they're changing it.

If you pass a component as the parentComponentToUse parameter, the pop-up bubble will be added as a child of that component when it's needed. If you pass nullptr, the pop-up will be placed on the desktop instead (note that it's a transparent window, so if you're using an OS that can't do transparent windows you'll have to add it to a parent component instead).

By default the popup display is shown when hovering will remain visible for 2 seconds, but it is possible to change this by passing a different hoverTimeout value. A value of -1 will cause the popup to remain until a mouseExit() occurs on the slider.

References juce::Component::Component(), and setPopupDisplayEnabled().

Referenced by setPopupDisplayEnabled().

## getCurrentPopupDisplay()

Component * juce::Slider::getCurrentPopupDisplay | ( |  | ) | const

noexcept

If a popup display is enabled and is currently visible, this returns the component that is being shown, or nullptr if none is currently in use.

See also
  setPopupDisplayEnabled

References juce::Component::Component(), and getCurrentPopupDisplay().

Referenced by getCurrentPopupDisplay().

## setPopupMenuEnabled()

void juce::Slider::setPopupMenuEnabled | ( | bool | menuEnabled | ) |

If this is set to true, then right-clicking on the slider will pop-up a menu to let the user change the way it works.

By default this is turned off, but when turned on, the menu will include things like velocity sensitivity, and for rotary sliders, whether they use a linear or rotary mouse-drag to move them.

References setPopupMenuEnabled().

Referenced by setPopupMenuEnabled().

## setScrollWheelEnabled()

void juce::Slider::setScrollWheelEnabled | ( | bool | enabled | ) |

This can be used to stop the mouse scroll-wheel from moving the slider.

By default it's enabled.

References setScrollWheelEnabled().

Referenced by setScrollWheelEnabled().

## isScrollWheelEnabled()

bool juce::Slider::isScrollWheelEnabled | ( |  | ) | const

noexcept

Returns true if the scroll wheel can move the slider.

References isScrollWheelEnabled().

Referenced by isScrollWheelEnabled().

## getThumbBeingDragged()

int juce::Slider::getThumbBeingDragged | ( |  | ) | const

noexcept

Returns a number to indicate which thumb is currently being dragged by the mouse.

This will return 0 for the main thumb, 1 for the minimum-value thumb, 2 for the maximum-value thumb, or -1 if none is currently down.

References getThumbBeingDragged().

Referenced by getThumbBeingDragged().

## startedDragging()

virtual void juce::Slider::startedDragging | ( |  | ) |

virtual

Callback to indicate that the user is about to start dragging the slider.

See also
  Slider::Listener::sliderDragStarted

References startedDragging().

Referenced by startedDragging().

## stoppedDragging()

virtual void juce::Slider::stoppedDragging | ( |  | ) |

virtual

Callback to indicate that the user has just stopped dragging the slider.

See also
  Slider::Listener::sliderDragEnded

References stoppedDragging().

Referenced by stoppedDragging().

## valueChanged()

virtual void juce::Slider::valueChanged | ( |  | ) |

virtual

Callback to indicate that the user has just moved the slider.

See also
  Slider::Listener::sliderValueChanged

References valueChanged().

Referenced by valueChanged().

## getValueFromText()

virtual double juce::Slider::getValueFromText | ( | const String & | text | ) |

virtual

Returns a slider value for some given text.

Subclasses can override this to convert a text string to a value. Alternatively assign a lambda to valueFromTextFunction.

When the user enters something into the text-entry box, this method is called to convert it to a value. The default implementation just tries to convert it to a double.

See also
  getTextFromValue, valueFromTextFunction, textFromValueFunction

References getValueFromText().

Referenced by getValueFromText().

## getTextFromValue()

virtual String juce::Slider::getTextFromValue | ( | double | value | ) |

virtual

Returns a text representation for a given slider value.

Subclasses can override this to customise the formatting of the text-entry box. Alternatively assign a lambda to textFromValueFunction.

The default implementation just turns the value into a string, using a number of decimal places based on the range interval. If a suffix string has been set using setTextValueSuffix(), this will be appended to the text.

See also
  getValueFromText, textFromValueFunction, valueFromTextFunction

References getTextFromValue().

Referenced by getTextFromValue().

## setTextValueSuffix()

void juce::Slider::setTextValueSuffix | ( | const String & | suffix | ) |

Sets a suffix to append to the end of the numeric value when it's displayed as a string.

This is used by the default implementation of getTextFromValue(), and is just appended to the numeric value. For more advanced formatting, you can override getTextFromValue() and do something else.

References setTextValueSuffix().

Referenced by setTextValueSuffix().

## getTextValueSuffix()

String juce::Slider::getTextValueSuffix | ( |  | ) | const

Returns the suffix that was set by setTextValueSuffix().

References getTextValueSuffix().

Referenced by getTextValueSuffix().

## getNumDecimalPlacesToDisplay()

int juce::Slider::getNumDecimalPlacesToDisplay | ( |  | ) | const

noexcept

Returns the best number of decimal places to use when displaying this slider's value.

It calculates the fewest decimal places needed to represent numbers with the slider's interval setting.

See also
  setNumDecimalPlacesToDisplay

References getNumDecimalPlacesToDisplay().

Referenced by getNumDecimalPlacesToDisplay().

## setNumDecimalPlacesToDisplay()

void juce::Slider::setNumDecimalPlacesToDisplay | ( | int | decimalPlacesToDisplay | ) |

Modifies the best number of decimal places to use when displaying this slider's value.

See also
  getNumDecimalPlacesToDisplay

References setNumDecimalPlacesToDisplay().

Referenced by setNumDecimalPlacesToDisplay().

## proportionOfLengthToValue()

virtual double juce::Slider::proportionOfLengthToValue | ( | double | proportion | ) |

virtual

Allows a user-defined mapping of distance along the slider to its value.

The default implementation for this performs the skewing operation that can be set up in the setSkewFactor() method. Override it if you need some kind of custom mapping instead, but make sure you also implement the inverse function in valueToProportionOfLength().

Parameters

  proportion | a value 0 to 1.0, indicating a distance along the slider

Returns
  the slider value that is represented by this position

See also
  valueToProportionOfLength

References proportionOfLengthToValue().

Referenced by proportionOfLengthToValue().

## valueToProportionOfLength()

virtual double juce::Slider::valueToProportionOfLength | ( | double | value | ) |

virtual

Allows a user-defined mapping of value to the position of the slider along its length.

The default implementation for this performs the skewing operation that can be set up in the setSkewFactor() method. Override it if you need some kind of custom mapping instead, but make sure you also implement the inverse function in proportionOfLengthToValue().

Parameters

  value | a valid slider value, between the range of values specified in setRange()

Returns
  a value 0 to 1.0 indicating the distance along the slider that represents this value

See also
  proportionOfLengthToValue

References valueToProportionOfLength().

Referenced by valueToProportionOfLength().

## getPositionOfValue()

float juce::Slider::getPositionOfValue | ( | double | value | ) | const

Returns the X or Y coordinate of a value along the slider's length.

If the slider is horizontal, this will be the X coordinate of the given value, relative to the left of the slider. If it's vertical, then this will be the Y coordinate, relative to the top of the slider.

If the slider is rotary, this will throw an assertion and return 0. If the value is out-of-range, it will be constrained to the length of the slider.

References getPositionOfValue().

Referenced by getPositionOfValue().

## snapValue()

virtual double juce::Slider::snapValue | ( | double | attemptedValue,
|  | DragMode | dragMode )

virtual

This can be overridden to allow the slider to snap to user-definable values.

If overridden, it will be called when the user tries to move the slider to a given position, and allows a subclass to sanity-check this value, possibly returning a different value to use instead.

Parameters

  attemptedValue | the value the user is trying to enter
  dragMode | indicates whether the user is dragging with the mouse; notDragging if they are entering the value using the text box or other non-dragging interaction

Returns
  the value to use instead

References snapValue().

Referenced by snapValue().

## updateText()

void juce::Slider::updateText | ( |  | ) |

This can be called to force the text box to update its contents.

(Not normally needed, as this is done automatically).

References updateText().

Referenced by updateText().

## isHorizontal()

bool juce::Slider::isHorizontal | ( |  | ) | const

noexcept

True if the slider moves horizontally.

References isHorizontal().

Referenced by isHorizontal().

## isVertical()

bool juce::Slider::isVertical | ( |  | ) | const

noexcept

True if the slider moves vertically.

References isVertical().

Referenced by isVertical().

## isRotary()

bool juce::Slider::isRotary | ( |  | ) | const

noexcept

True if the slider is in a rotary mode.

References isRotary().

Referenced by isRotary().

## isBar()

bool juce::Slider::isBar | ( |  | ) | const

noexcept

True if the slider is in a linear bar mode.

References isBar().

Referenced by isBar().

## isTwoValue()

bool juce::Slider::isTwoValue | ( |  | ) | const

noexcept

True if the slider has two thumbs.

References isTwoValue().

Referenced by isTwoValue().

## isThreeValue()

bool juce::Slider::isThreeValue | ( |  | ) | const

noexcept

True if the slider has three thumbs.

References isThreeValue().

Referenced by isThreeValue().

## paint()

void juce::Slider::paint | ( | Graphics & | g | ) |

override virtual

Components can override this method to draw their content.

The paint() method gets called when a region of a component needs redrawing, either because the component's repaint() method has been called, or because something has happened on the screen that means a section of a window needs to be redrawn.

Any child components will draw themselves over whatever this method draws. If you need to paint over the top of your child components, you can also implement the paintOverChildren() method to do this.

If you want to cause a component to redraw itself, this is done asynchronously - calling the repaint() method marks a region of the component as "dirty", and the paint() method will automatically be called sometime later, by the message thread, to paint any bits that need refreshing. In JUCE (and almost all modern UI frameworks), you never redraw something synchronously.

You should never need to call this method directly - to take a snapshot of the component you could use createComponentSnapshot() or paintEntireComponent().

Parameters

  g | the graphics context that must be used to do the drawing operations.

See also
  repaint, paintOverChildren, Graphics

Reimplemented from juce::Component.

## resized()

void juce::Slider::resized | ( |  | ) |

override virtual

Called when this component's size has been changed.

A component can implement this method to do things such as laying out its child components when its width or height changes.

The method is called synchronously as a result of the setBounds or setSize methods, so repeatedly changing a components size will repeatedly call its resized method (unlike things like repainting, where multiple calls to repaint are coalesced together).

If the component is a top-level window on the desktop, its size could also be changed by operating-system factors beyond the application's control.

See also
  moved, setSize

Reimplemented from juce::Component.

## mouseDown()

void juce::Slider::mouseDown | ( | const MouseEvent & | event | ) |

override virtual

Called when a mouse button is pressed.

The MouseEvent object passed in contains lots of methods for finding out which button was pressed, as well as which modifier keys (e.g. shift, ctrl) were held down at the time.

Once a button is held down, the mouseDrag method will be called when the mouse moves, until the button is released.

Parameters

  event | details about the position and status of the mouse event, including the source component in which it occurred

See also
  mouseUp, mouseDrag, mouseDoubleClick, contains

Reimplemented from juce::Component.

## mouseUp()

void juce::Slider::mouseUp | ( | const MouseEvent & | event | ) |

override virtual

Called when a mouse button is released.

A mouseUp callback is sent to the component in which a button was pressed even if the mouse is actually over a different component when the button is released.

The MouseEvent object passed in contains lots of methods for finding out which buttons were down just before they were released.

Parameters

  event | details about the position and status of the mouse event, including the source component in which it occurred

See also
  mouseDown, mouseDrag, mouseDoubleClick, contains

Reimplemented from juce::Component.

## mouseDrag()

void juce::Slider::mouseDrag | ( | const MouseEvent & | event | ) |

override virtual

Called when the mouse is moved while a button is held down.

When a mouse button is pressed inside a component, that component receives mouseDrag callbacks each time the mouse moves, even if the mouse strays outside the component's bounds.

Parameters

  event | details about the position and status of the mouse event, including the source component in which it occurred

See also
  mouseDown, mouseUp, mouseMove, contains, setDragRepeatInterval

Reimplemented from juce::Component.

## mouseDoubleClick()

void juce::Slider::mouseDoubleClick | ( | const MouseEvent & | event | ) |

override virtual

Called when a mouse button has been double-clicked on a component.

The MouseEvent object passed in contains lots of methods for finding out which button was pressed, as well as which modifier keys (e.g. shift, ctrl) were held down at the time.

Parameters

  event | details about the position and status of the mouse event, including the source component in which it occurred

See also
  mouseDown, mouseUp

Reimplemented from juce::Component.

## mouseWheelMove()

void juce::Slider::mouseWheelMove | ( | const MouseEvent & | event,
|  | const MouseWheelDetails & | wheel )

override virtual

Called when the mouse-wheel is moved.

This callback is sent to the component that the mouse is over when the wheel is moved.

If not overridden, a component will forward this message to its parent, so that parent components can collect mouse-wheel messages that happen to child components which aren't interested in them. (Bear in mind that if you attach a component as a mouse-listener to other components, then those wheel moves will also end up calling this method and being passed up to the parents, which may not be what you intended to happen).

Parameters

  event | details about the mouse event
  wheel | details about the mouse wheel movement

Reimplemented from juce::Component.

## modifierKeysChanged()

void juce::Slider::modifierKeysChanged | ( | const ModifierKeys & | modifiers | ) |

override virtual

Called when a modifier key is pressed or released.

Whenever the shift, control, alt or command keys are pressed or released, this method will be called.

The component that is currently under the main mouse pointer will be tried first and, if there is no component currently under the pointer, the component that currently has the keyboard focus will have this method called. Remember that a component will only be given the focus if its setWantsKeyboardFocus() method has been used to enable this.

The default implementation of this method actually calls its parent's modifierKeysChanged method, so that focused components which aren't interested in this will give their parents a chance to act on the event instead.

See also
  keyStateChanged, ModifierKeys

Reimplemented from juce::Component.

## lookAndFeelChanged()

void juce::Slider::lookAndFeelChanged | ( |  | ) |

override virtual

Called to let the component react to a change in the look-and-feel setting.

When the look-and-feel is changed for a component, this method, repaint(), and colourChanged() are called on the original component and all its children recursively.

It can also be triggered manually by the sendLookAndFeelChange() method, in case an application uses a LookAndFeel class that might have changed internally.

See also
  sendLookAndFeelChange, getLookAndFeel

Reimplemented from juce::Component.

## enablementChanged()

void juce::Slider::enablementChanged | ( |  | ) |

override virtual

Callback to indicate that this component has been enabled or disabled.

This can be triggered by one of the component's parent components being enabled or disabled, as well as changes to the component itself.

The default implementation of this method does nothing; your class may wish to repaint itself or something when this happens.

See also
  setEnabled, isEnabled

Reimplemented from juce::Component.

## focusOfChildComponentChanged()

void juce::Slider::focusOfChildComponentChanged | ( | FocusChangeType | cause | ) |

override virtual

Called to indicate a change in whether or not this component is the parent of the currently-focused component.

Essentially this is called when the return value of a call to hasKeyboardFocus (true) has changed. It happens when focus moves from one of this component's children (at any depth) to a component that isn't contained in this one, (or vice-versa). Note that this method does NOT get called to when focus simply moves from one of its child components to another.

See also
  focusGained, setWantsKeyboardFocus, getCurrentlyFocusedComponent, hasKeyboardFocus

Reimplemented from juce::Component.

## colourChanged()

void juce::Slider::colourChanged | ( |  | ) |

override virtual

This method is called when a colour is changed by the setColour() method, or when the look-and-feel is changed by the setLookAndFeel() or sendLookAndFeelChange() methods.

See also
  setColour, findColour, setLookAndFeel, sendLookAndFeelChange

Reimplemented from juce::Component.

## mouseMove()

void juce::Slider::mouseMove | ( | const MouseEvent & | event | ) |

override virtual

Called when the mouse moves inside a component.

If the mouse button isn't pressed and the mouse moves over a component, this will be called to let the component react to this.

A component will always get a mouseEnter callback before a mouseMove.

Parameters

  event | details about the position and status of the mouse event, including the source component in which it occurred

See also
  mouseEnter, mouseExit, mouseDrag, contains

Reimplemented from juce::Component.

## mouseExit()

void juce::Slider::mouseExit | ( | const MouseEvent & | event | ) |

override virtual

Called when the mouse moves out of a component.

This will be called when the mouse moves off the edge of this component.

If the mouse button was pressed, and it was then dragged off the edge of the component and released, then this callback will happen when the button is released, after the mouseUp callback.

Parameters

  event | details about the position and status of the mouse event, including the source component in which it occurred

See also
  mouseEnter, mouseDrag, mouseMove, contains

Reimplemented from juce::Component.

## mouseEnter()

void juce::Slider::mouseEnter | ( | const MouseEvent & | event | ) |

override virtual

Called when the mouse first enters a component.

If the mouse button isn't pressed and the mouse moves into a component, this will be called to let the component react to this.

When the mouse button is pressed and held down while being moved in or out of a component, no mouseEnter or mouseExit callbacks are made - only mouseDrag messages are sent to the component that the mouse was originally clicked on, until the button is released.

Parameters

  event | details about the position and status of the mouse event, including the source component in which it occurred

See also
  mouseExit, mouseDrag, mouseMove, contains

Reimplemented from juce::Component.

## keyPressed()

bool juce::Slider::keyPressed | ( | const KeyPress & | key | ) |

override virtual

Called when a key is pressed.

When a key is pressed, the component that has the keyboard focus will have this method called. Remember that a component will only be given the focus if its setWantsKeyboardFocus() method has been used to enable this.

If your implementation returns true, the event will be consumed and not passed on to any other listeners. If it returns false, the key will be passed to any KeyListeners that have been registered with this component. As soon as one of these returns true, the process will stop, but if they all return false, the event will be passed upwards to this component's parent, and so on.

The default implementation of this method does nothing and returns false.

See also
  keyStateChanged, getCurrentlyFocusedComponent, addKeyListener

Reimplemented from juce::Component.

## createAccessibilityHandler()

std::unique_ptr< AccessibilityHandler > juce::Slider::createAccessibilityHandler | ( |  | ) |

override virtual

Override this method to return a custom AccessibilityHandler for this component.

The default implementation creates and returns a AccessibilityHandler object with an unspecified role, meaning that it will be visible to accessibility clients but without a specific role, action callbacks or interfaces. To control how accessibility clients see and interact with your component subclass AccessibilityHandler, implement the desired behaviours, and return an instance of it from this method in your component subclass.

The accessibility handler you return here is guaranteed to be destroyed before its Component, so it's safe to store and use a reference back to the Component inside the AccessibilityHandler if necessary.

This function should rarely be called directly. If you need to query a component's accessibility handler, it's normally better to call getAccessibilityHandler(). The exception to this rule is derived implementations of createAccessibilityHandler(), which may find it useful to call the base class implementation, and then wrap or modify the result.

See also
  getAccessibilityHandler

Reimplemented from juce::Component.

References setMaxValue(), setMinAndMaxValues(), setMinValue(), setValue(), and Slider().

## Member Data Documentation

## onValueChange

std::function<void()> juce::Slider::onValueChange

You can assign a lambda to this callback object to have it called when the slider value is changed.

## onDragStart

std::function<void()> juce::Slider::onDragStart

You can assign a lambda to this callback object to have it called when the slider's drag begins.

## onDragEnd

std::function<void()> juce::Slider::onDragEnd

You can assign a lambda to this callback object to have it called when the slider's drag ends.

## valueFromTextFunction

std::function<double (const String&)> juce::Slider::valueFromTextFunction

You can assign a lambda that will be used to convert text to a slider value.

## textFromValueFunction

std::function<String (double)> juce::Slider::textFromValueFunction

You can assign a lambda that will be used to convert a slider value to text.

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited